﻿using ININ.PureCloud.OAuthControl;
using PureCloudPlatform.Client.V2.Api;
using PureCloudPlatform.Client.V2.Client;
using PureCloudPlatform.Client.V2.Model;
using System;
using System.Windows.Forms;

namespace <%= namespace %>
{
    public partial class Form1 : Form
    {
        OAuthWebBrowserForm loginForm = new OAuthWebBrowserForm();
        ConversationsApi conversationsApi = new ConversationsApi();

        public Form1()
        {
            InitializeComponent();
        }

        private void btnLogin_Click(object sender, EventArgs e)
        {
            //Login to PureCloud
            loginForm.oAuthWebBrowser1.ClientId = txtClientId.Text;
            loginForm.oAuthWebBrowser1.Environment = "<%= environment %>";
            loginForm.oAuthWebBrowser1.RedirectUriIsFake = true; // We're not a web browser, we are a desktop app
            loginForm.oAuthWebBrowser1.RedirectUri = "<%= redirectUri %>"; // Even though it's fake, make sure it matches what you set in PureCloud oAuth Admin

            var result = loginForm.ShowDialog();

            switch (result)
            {
                case DialogResult.OK:
                    // We are connected!
                    txtAccessToken.Text = loginForm.oAuthWebBrowser1.AccessToken;
                    Configuration.Default.ApiClient.RestClient.BaseUrl = new Uri("https://api.<%= environment %>");
                    Configuration.Default.AccessToken = loginForm.oAuthWebBrowser1.AccessToken;
                    btnLogin.Enabled = false;
                    break;
                default:
                    btnLogin.Enabled = true;
                    txtAccessToken.Text = string.Empty;
                    break;
            }
        }

        private void btnCall_Click(object sender, EventArgs e)
        {
            var response = conversationsApi.PostConversationsCalls(new CreateCallRequest()
            {
                PhoneNumber = txtPhoneNumber.Text
            });
            txtConversationId.Text = response.Id;
        }

        private void btnDisconnect_Click(object sender, EventArgs e)
        {
            if (txtConversationId.Text == string.Empty)
            {
                return;
            }
            var conversation = conversationsApi.GetConversation(txtConversationId.Text);
            conversationsApi.PatchConversationParticipant(conversation.Id, conversation.Participants[0].Id, new MediaParticipantRequest()
            {
                State = MediaParticipantRequest.StateEnum.Disconnected
            });
        }
    }
}
